<template>
  <div class="app-container pageSediment">
    <el-form v-show="showSearch" ref="queryForm" :inline="true" :model="queryParams" label-width="100px">
      <el-form-item label="检查类型名称" prop="typeName">
        <el-input
          v-model="queryParams.typeName"
          clearable
          placeholder="请输入检查类型名称"
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button icon="el-icon-search" size="mini" type="cyan" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        <el-button
          v-hasPermi="['basis:examtype:add']"
          icon="el-icon-plus"
          size="mini"
          type="primary"
          @click="handleAdd"
        >新增</el-button>
        <el-button
          v-hasPermi="['basis:examtype:edit']"
          :disabled="single"
          icon="el-icon-edit"
          size="mini"
          type="success"
          @click="handleUpdate"
        >修改</el-button>
        <el-button
          v-hasPermi="['basis:examtype:remove']"
          :disabled="multiple"
          icon="el-icon-delete"
          size="mini"
          type="danger"
          @click="handleDelete"
        >删除</el-button>
      </el-form-item>
    </el-form>

    <el-table ref="multipleTable" v-loading="loading"
              :data="examtypeList" border stripe tooltip-effect="light"  @row-click="handleRowClick"
              @selection-change="handleSelectionChange">
      <el-table-column align="center" type="selection" width="55" />
      <el-table-column align="left" fixed='left' label="检查类型编码" prop="typeCode" show-overflow-tooltip width="100" />
      <el-table-column align="left" fixed='left' label="检查类型名称" prop="typeName" show-overflow-tooltip width="120" />
<!--      <el-table-column label="拼音码" align="center" prop="pyCode" show-overflow-tooltip width="120"/>-->
      <el-table-column align="left" label="注意事项" min-width="400" prop="generalRemarks" show-overflow-tooltip sortable="false">

      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :limit.sync="queryParams.pageSize"
      :page.sync="queryParams.pageNum"
      :total="total"
      @pagination="getList"
    />

    <!-- 添加或修改检查类型对话框 -->
    <el-dialog v-dialogDrag :title="title" :visible.sync="open" append-to-body width="500px">
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="检查类型" prop="typeCode">
          <el-input v-model="form.typeName" placeholder="请输入检查类型"/>
        </el-form-item>
        <el-form-item label="检查类型编码" prop="typeName">
          <el-input v-model="form.typeCode" placeholder="请输入检查类型编码"/>
        </el-form-item>
        <el-form-item label="注意事项" prop="generalRemarks">
          <el-input v-model="form.generalRemarks" autosize placeholder="请输入注意事项" type="textarea"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listExamtype, getExamtype, delExamtype, addExamtype, updateExamtype, exportExamtype } from "@/api/basis/examtype";
import vPinyin from '@/utils/vue-py';//拼音码转换
export default {
  name: "Examtype",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 检查类型表格数据
      examtypeList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        typeCode: null,
        typeName: null,
        pyCode: null,
        generalRemarks: null,
        isValid: null,
        createdById: null,
        createdByName: null,
        createdAt: null,
        updatedById: null,
        updatedByName: null,
        updatedAt: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        typeCode: [
          { required: true, message: "检查类型不能为空", trigger: "blur" }
        ],
        typeName: [
          { required: true, message: "检查类型编码不能为空", trigger: "blur" }
        ],
        generalRemarks: [
          { required: true, message: "注意事项不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询检查类型列表 */
    getList() {
      this.loading = true;
      listExamtype(this.queryParams).then(response => {
        this.examtypeList = response.rows.sort((x,y)=>parseInt(x.typeCode)-parseInt(y.typeCode));
        this.total = response.total;
        this.loading = false;
      });
    },
    handleRowClick(	row, column, event){
      this.$refs.multipleTable.toggleRowSelection(row);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        typeCode: null,
        typeName: null,
        pyCode: null,
        generalRemarks: null,
        isValid: null,
        createdById: null,
        createdByName: null,
        createdAt: null,
        updatedById: null,
        updatedByName: null,
        updatedAt: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加检查类型";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getExamtype(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改检查类型";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        //拼音码自动转换
        if(this.form.typeName !=null && this.form.typeName!=''){
           this.form.pyCode=vPinyin.chineseToPinYin(this.form.typeName);
        }
        if (valid) {
          if (this.form.id != null) {
            updateExamtype(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addExamtype(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除检查类型编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delExamtype(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有检查类型数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportExamtype(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    }
  }
};
</script>
